## ignition-sensors3 3.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-sensors3 VERSION 3.3.0)

#============================================================================
# Find ignition-cmake
#============================================================================
find_package(ignition-cmake2 2.8.0 REQUIRED)

#============================================================================
# Configure the project
#============================================================================
ign_configure_project()

#============================================================================
# Set project-specific options
#============================================================================
set (DRI_TESTS TRUE CACHE BOOL "True to enable DRI tests")

option(ENABLE_PROFILER "Enable Ignition Profiler" FALSE)

if(ENABLE_PROFILER)
  add_definitions("-DIGN_PROFILER_ENABLE=1")
else()
  add_definitions("-DIGN_PROFILER_ENABLE=0")
endif()

#============================================================================
# Search for project-specific dependencies
#============================================================================
message(STATUS "\n\n-- ====== Finding Dependencies ======")

#--------------------------------------
# Find Protobuf
set(REQ_PROTOBUF_VER 3)
ign_find_package(IgnProtobuf
                 VERSION ${REQ_PROTOBUF_VER}
                 REQUIRED
                 PRETTY Protobuf)

#--------------------------------------
# Find ignition-math
ign_find_package(ignition-math6 REQUIRED)
set(IGN_MATH_VER ${ignition-math6_VERSION_MAJOR})

#--------------------------------------
# Find ignition-common
ign_find_package(ignition-common3
                 COMPONENTS profiler
                 REQUIRED)
set(IGN_COMMON_VER ${ignition-common3_VERSION_MAJOR})

#--------------------------------------
# Find ignition-transport
ign_find_package(ignition-transport8 REQUIRED)
set(IGN_TRANSPORT_VER ${ignition-transport8_VERSION_MAJOR})

#--------------------------------------
# Find ignition-rendering
ign_find_package(ignition-rendering3 REQUIRED OPTIONAL_COMPONENTS ogre ogre2)
set(IGN_RENDERING_VER ${ignition-rendering3_VERSION_MAJOR})

if (TARGET ignition-rendering${IGN_RENDERING_VER}::ogre)
  set(HAVE_OGRE TRUE)
  add_definitions(-DWITH_OGRE)
endif()

if (TARGET ignition-rendering${IGN_RENDERING_VER}::ogre2)
  set(HAVE_OGRE2 TRUE)
  add_definitions(-DWITH_OGRE2)
endif()

#--------------------------------------
# Find ignition-msgs
ign_find_package(ignition-msgs5 REQUIRED)
set(IGN_MSGS_VER ${ignition-msgs5_VERSION_MAJOR})

#--------------------------------------
# Find ignition-plugin
ign_find_package(ignition-plugin1 REQUIRED COMPONENTS all)
set(IGN_PLUGIN_VER ${ignition-plugin1_VERSION_MAJOR})

#--------------------------------------
# Find SDFormat
ign_find_package(sdformat9 REQUIRED)
set(SDF_VER ${sdformat9_VERSION_MAJOR})

set(IGN_SENSORS_PLUGIN_PATH ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS)

#============================================================================
# Create package information
#============================================================================
ign_create_packages()

#============================================================================
# Configure documentation
#============================================================================
configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)

ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md")

if(TARGET doc)
  file(COPY ${CMAKE_SOURCE_DIR}/tutorials/files/ DESTINATION ${CMAKE_BINARY_DIR}/doxygen/html/files/)
endif()

=== debian/changelog ===
ignition-sensors3 (3.3.0-1~buster) buster; urgency=medium

  * ignition-sensors3 3.3.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Mon, 30 Aug 2021 14:40:34 -0700

ignition-sensors3 (3.2.0-1~buster) buster; urgency=medium

  * ignition-sensors3 3.2.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Mon, 08 Feb 2021 12:50:48 -0700

ignition-sensors3 (3.1.0-1~buster) buster; urgency=medium

  * ignition-sensors3 3.1.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 03 Sep 2020 12:01:04 -0700

ignition-sensors3 (3.0.0-2~buster) buster; urgency=medium

  * Fix install file name

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 20 Apr 2020 18:11:55 +0200

ignition-sensors3 (3.0.0-1~buster) buster; urgency=medium

  * ignition-sensors3 3.0.0-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 10 Dec 2019 17:57:11 +0100

=== debian/control ===
Source: ignition-sensors3
Standards-Version: 3.9.8
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               doxygen,
               pkg-config,
               debhelper (>= 9),
               libignition-cmake2-dev (>= 2.8.0),
               libignition-common3-events-dev,
               libignition-common3-profiler-dev,
               libignition-math6-dev,
               libignition-msgs5-dev,
               libignition-plugin-dev,
               libignition-rendering3-ogre1-dev,
               libignition-rendering3-ogre2-dev,
               libignition-transport8-core-dev,
               libignition-tools-dev,
               libsdformat9-dev
Vcs-Browser: https://github.com/ignition-release/ign-sensors3-release
Vcs-Hg: https://github.com/ignition-release/ign-sensors3-release
Homepage: http://ignitionrobotics.org/

Package: libignition-sensors3-core-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.8.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-plugin-dev,
         libignition-rendering3-ogre1-dev,
         libignition-rendering3-ogre2-dev,
         libignition-transport8-core-dev,
         libignition-tools-dev,
         libsdformat9-dev,
         libignition-sensors3 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Development files
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.

Package: libignition-sensors3
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Shared library
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.

Package: libignition-sensors3-air-pressure-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.8.0),
         libignition-common3-events-dev,
         libignition-sensors3-core-dev,
         libsdformat9-dev,
         libignition-sensors3-air-pressure (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Dev files air-pressure
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for air-pressure sensor

Package: libignition-sensors3-air-pressure
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Lib air-pressure
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for air-pressure sensor

Package: libignition-sensors3-altimeter-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.8.0),
         libignition-common3-events-dev,
         libignition-sensors3-core-dev,
         libsdformat9-dev,
         libignition-sensors3-altimeter (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Dev files altimeter
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for altimeter sensor

Package: libignition-sensors3-altimeter
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Lib altimeter
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for altimeter sensor


Package: libignition-sensors3-camera-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.8.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-transport8-core-dev,
         libignition-sensors3-core-dev,
         libsdformat9-dev,
         libignition-sensors3-camera (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Dev files Camera
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for Camera sensor

Package: libignition-sensors3-camera
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Lib Camera
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for Camera sensor

Package: libignition-sensors3-depth-camera-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.8.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-transport8-core-dev,
         libignition-sensors3-core-dev,
         libignition-sensors3-camera-dev,
         libsdformat9-dev,
         libignition-sensors3-depth-camera (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Dev files depth-camera
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for depth-camera sensor

Package: libignition-sensors3-depth-camera
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Lib depth-camera
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  . Shared library for depth-camera sensor

Package: libignition-sensors3-imu-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.8.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-sensors3-core-dev,
         libsdformat9-dev,
         libignition-sensors3-imu (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Dev files imu
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for imu sensor

Package: libignition-sensors3-imu
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Lib imu
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for imu sensor


Package: libignition-sensors3-lidar-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.8.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-transport8-core-dev,
         libignition-sensors3-core-dev,
         libsdformat9-dev,
         libignition-sensors3-lidar (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Dev files lidar
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for lidar sensor

Package: libignition-sensors3-lidar
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Lib lidar
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for lidar sensor

Package: libignition-sensors3-gpu-lidar-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.8.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-transport8-core-dev,
         libignition-sensors3-core-dev,
         libignition-sensors3-lidar-dev,
         libsdformat9-dev,
         libignition-sensors3-gpu-lidar (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Dev files gpu-lidar
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for gpu-lidar sensor

Package: libignition-sensors3-gpu-lidar
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Lib gpu-lidar
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for gpu-lidar sensor

Package: libignition-sensors3-logical-camera-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.8.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-transport8-core-dev,
         libignition-sensors3-core-dev,
         libsdformat9-dev,
         libignition-sensors3-logical-camera (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Dev files logical-camera
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for logical-camera sensor

Package: libignition-sensors3-logical-camera
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Lib logical-camera
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for logical-camera sensor

Package: libignition-sensors3-magnetometer-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.8.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-sensors3-core-dev,
         libsdformat9-dev,
         libignition-sensors3-magnetometer (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Dev files magnetometer
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for magnetometer sensor

Package: libignition-sensors3-magnetometer
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition sensors2 classes and functions for robot apps - Lib magnetometer
  Ignition sensors2 is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for magnetometer sensor

## ignition-sensors3 3.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,12 +3,12 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-sensors3 VERSION 3.3.0)
+project(ignition-sensors3 VERSION 3.4.0)
 
 #============================================================================
 # Find ignition-cmake
 #============================================================================
-find_package(ignition-cmake2 2.8.0 REQUIRED)
+find_package(ignition-cmake2 2.13 REQUIRED)
 
 #============================================================================
 # Configure the project
@@ -55,11 +55,17 @@
 
 #--------------------------------------
 # Find ignition-transport
-ign_find_package(ignition-transport8 REQUIRED)
+ign_find_package(ignition-transport8 REQUIRED VERSION 8.2)
 set(IGN_TRANSPORT_VER ${ignition-transport8_VERSION_MAJOR})
 
 #--------------------------------------
 # Find ignition-rendering
+
+# See CMP0072 for more details (cmake --help-policy CMP0072)
+if ((NOT ${CMAKE_VERSION} VERSION_LESS 3.11) AND (NOT OpenGL_GL_PREFERENCE))
+  set(OpenGL_GL_PREFERENCE "GLVND")
+endif()
+
 ign_find_package(ignition-rendering3 REQUIRED OPTIONAL_COMPONENTS ogre ogre2)
 set(IGN_RENDERING_VER ${ignition-rendering3_VERSION_MAJOR})

=== src/CMakeLists.txt ===
set (sources
  Manager.cc
  Sensor.cc
  Noise.cc
  GaussianNoiseModel.cc
  PointCloudUtil.cc
  SensorFactory.cc
  SensorTypes.cc
)

set(rendering_sources
  RenderingSensor.cc
  RenderingEvents.cc
  ImageGaussianNoiseModel.cc
  ImageNoise.cc
)

set (gtest_sources
  Manager_TEST.cc
  Noise_TEST.cc
  Sensor_TEST.cc
)

if (MSVC)
  # TODO(louise) Remove this once warnings are suppressed in ign-rendering
  set_source_files_properties(
      ${rendering_sources}
    COMPILE_FLAGS "/wd4251"
  )
endif()

# Create the library target.
ign_create_core_library(SOURCES ${sources} CXX_STANDARD 14)

# todo(anyone) dependency on rendering has been moved to its own component
# and relevant functions are deprecated in ign-sensors 2. We can remove linking
# against ign-rendering from the core lib in ign-sensors 3
target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER}
    ignition-common${IGN_COMMON_VER}::ignition-common${IGN_COMMON_VER}
    ignition-transport${IGN_TRANSPORT_VER}::ignition-transport${IGN_TRANSPORT_VER}
    sdformat${SDF_VER}::sdformat${SDF_VER}
  PRIVATE
    ignition-common${IGN_COMMON_VER}::profiler
)
target_compile_definitions(${PROJECT_LIBRARY_TARGET_NAME} PUBLIC DepthPoints_EXPORTS)

ign_add_component(rendering SOURCES ${rendering_sources} GET_TARGET_NAME rendering_target)
target_link_libraries(${rendering_target}
  PUBLIC
    ignition-rendering${IGN_RENDERING_VER}::ignition-rendering${IGN_RENDERING_VER}
)

set(camera_sources CameraSensor.cc)
ign_add_component(camera SOURCES ${camera_sources} GET_TARGET_NAME camera_target)
# custom compile definitions since the one provided automatically is versioned and will
# make the code need to change with every major version
target_compile_definitions(${camera_target} PUBLIC CameraSensor_EXPORTS)
target_link_libraries(${camera_target}
  PUBLIC
    ${rendering_target}
  PRIVATE
    ignition-msgs${IGN_MSGS_VER}::ignition-msgs${IGN_MSGS_VER}
    ignition-transport${IGN_TRANSPORT_VER}::ignition-transport${IGN_TRANSPORT_VER}
)

set(depth_camera_sources DepthCameraSensor.cc)
ign_add_component(depth_camera SOURCES ${depth_camera_sources} GET_TARGET_NAME depth_camera_target)
target_compile_definitions(${depth_camera_target} PUBLIC DepthCameraSensor_EXPORTS)
target_link_libraries(${depth_camera_target}
  PRIVATE
    ${camera_target}
    ignition-msgs${IGN_MSGS_VER}::ignition-msgs${IGN_MSGS_VER}
    ignition-transport${IGN_TRANSPORT_VER}::ignition-transport${IGN_TRANSPORT_VER}
)

set(lidar_sources Lidar.cc)
ign_add_component(lidar SOURCES ${lidar_sources} GET_TARGET_NAME lidar_target)
target_compile_definitions(${lidar_target} PUBLIC Lidar_EXPORTS)
target_link_libraries(${lidar_target}
  PUBLIC
    ${rendering_target}
  PRIVATE
    ignition-msgs${IGN_MSGS_VER}::ignition-msgs${IGN_MSGS_VER}
    ignition-transport${IGN_TRANSPORT_VER}::ignition-transport${IGN_TRANSPORT_VER}
)

set(gpu_lidar_sources GpuLidarSensor.cc)
ign_add_component(gpu_lidar SOURCES ${gpu_lidar_sources} GET_TARGET_NAME gpu_lidar_target)
target_compile_definitions(${gpu_lidar_target} PUBLIC GpuLidarSensor_EXPORTS)
target_link_libraries(${gpu_lidar_target}
  PRIVATE
    ignition-msgs${IGN_MSGS_VER}::ignition-msgs${IGN_MSGS_VER}
    ignition-transport${IGN_TRANSPORT_VER}::ignition-transport${IGN_TRANSPORT_VER}
    ${lidar_target}
)

set(logical_camera_sources LogicalCameraSensor.cc)
ign_add_component(logical_camera SOURCES ${logical_camera_sources} GET_TARGET_NAME logical_camera_target)
target_compile_definitions(${logical_camera_target} PUBLIC LogicalCameraSensor_EXPORTS)
target_link_libraries(${logical_camera_target}
  PRIVATE
    ignition-msgs${IGN_MSGS_VER}::ignition-msgs${IGN_MSGS_VER}
    ignition-transport${IGN_TRANSPORT_VER}::ignition-transport${IGN_TRANSPORT_VER}
)

set(magnetometer_sources MagnetometerSensor.cc)
ign_add_component(magnetometer SOURCES ${magnetometer_sources} GET_TARGET_NAME magnetometer_target)

set(imu_sources ImuSensor.cc)
ign_add_component(imu SOURCES ${imu_sources} GET_TARGET_NAME imu_target)

set(altimeter_sources AltimeterSensor.cc)
ign_add_component(altimeter SOURCES ${altimeter_sources} GET_TARGET_NAME altimeter_target)

set(air_pressure_sources AirPressureSensor.cc)
ign_add_component(air_pressure SOURCES ${air_pressure_sources} GET_TARGET_NAME air_pressure_target)

set(rgbd_camera_sources RgbdCameraSensor.cc)
ign_add_component(rgbd_camera SOURCES ${rgbd_camera_sources} GET_TARGET_NAME rgbd_camera_target)
target_compile_definitions(${rgbd_camera_target} PUBLIC RgbdCameraSensor_EXPORTS)
target_link_libraries(${rgbd_camera_target}
  PRIVATE
    ${camera_target}
    ignition-msgs${IGN_MSGS_VER}::ignition-msgs${IGN_MSGS_VER}
    ignition-transport${IGN_TRANSPORT_VER}::ignition-transport${IGN_TRANSPORT_VER}
)

set(thermal_camera_sources ThermalCameraSensor.cc)
ign_add_component(thermal_camera SOURCES ${thermal_camera_sources} GET_TARGET_NAME thermal_camera_target)
target_link_libraries(${thermal_camera_target}
  PRIVATE
    ${camera_target}
    ignition-msgs${IGN_MSGS_VER}::ignition-msgs${IGN_MSGS_VER}
    ignition-transport${IGN_TRANSPORT_VER}::ignition-transport${IGN_TRANSPORT_VER}
)

# Build the unit tests.
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources} LIB_DEPS ${rendering_target})

# Build the unit tests that depend on components.
ign_build_tests(TYPE UNIT SOURCES Lidar_TEST.cc LIB_DEPS ${lidar_target})
ign_build_tests(TYPE UNIT SOURCES Camera_TEST.cc LIB_DEPS ${camera_target})
ign_build_tests(TYPE UNIT SOURCES ImuSensor_TEST.cc LIB_DEPS ${imu_target})

set(plugin_test_targets)
list(APPEND plugin_test_targets "UNIT_Camera_TEST")
list(APPEND plugin_test_targets "UNIT_Lidar_TEST")
list(APPEND plugin_test_targets "UNIT_ImuSensor_TEST")

foreach(plugin_test ${plugin_test_targets})
  if(TARGET ${plugin_test})
    set(_env_vars)
    list(APPEND _env_vars "IGN_PLUGIN_PATH=$<TARGET_FILE_DIR:${camera_target}>")
    list(APPEND _env_vars "DYLD_LIBRARY_PATH=${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

    set_tests_properties(${plugin_test} PROPERTIES
      ENVIRONMENT "${_env_vars}")
  endif()
endforeach()

=== examples/imu_noise/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(ignition-sensors-noise-demo)

# Find the Ignition Libraries used directly by the example
find_package(ignition-sensors3 REQUIRED)

add_executable(sensor_noise main.cc)
target_link_libraries(sensor_noise PUBLIC ignition-sensors3)

=== examples/save_image/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(ignition-sensors-camera-demo)

# Find the Ignition Libraries used directly by the example
find_package(ignition-rendering3 REQUIRED OPTIONAL_COMPONENTS ogre ogre2)
find_package(ignition-sensors3 REQUIRED COMPONENTS rendering camera)

if (TARGET ignition-rendering3::ogre)
   add_definitions(-DWITH_OGRE)
endif()
if (TARGET ignition-rendering3::ogre2)
   add_definitions(-DWITH_OGRE2)
endif()

add_executable(save_image main.cc)
target_link_libraries(save_image PUBLIC
  ignition-sensors3::camera)

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

set(dri_tests
  camera_plugin.cc
  depth_camera_plugin.cc
  gpu_lidar_sensor_plugin.cc
  rgbd_camera_plugin.cc
  thermal_camera_plugin.cc
)

set(tests
  air_pressure_plugin.cc
  altimeter_plugin.cc
  logical_camera_plugin.cc
  magnetometer_plugin.cc
  imu_plugin.cc
)

link_directories(${PROJECT_BINARY_DIR}/test)

include_directories(${PROJECT_SOURCE_DIR}/src)

# Test symbols having the right name on linux only
if (UNIX AND NOT APPLE)
  configure_file(all_symbols_have_version.bash.in ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash @ONLY)
  add_test(NAME INTEGRATION_versioned_symbols
    COMMAND bash ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash $<TARGET_FILE:${PROJECT_LIBRARY_TARGET_NAME}>)
endif()

if (DRI_TESTS)
  ign_build_tests(TYPE INTEGRATION
    SOURCES
      ${dri_tests}
    LIB_DEPS
      ${IGNITION-TRANSPORT_LIBRARIES}
      ${PROJECT_LIBRARY_TARGET_NAME}-depth_camera
      ${PROJECT_LIBRARY_TARGET_NAME}-camera
      ${PROJECT_LIBRARY_TARGET_NAME}-lidar
      ${PROJECT_LIBRARY_TARGET_NAME}-gpu_lidar
      ${PROJECT_LIBRARY_TARGET_NAME}-rgbd_camera
      ${PROJECT_LIBRARY_TARGET_NAME}-thermal_camera
  )
endif()

ign_build_tests(TYPE INTEGRATION
  SOURCES
    ${tests}
  LIB_DEPS
    ${PROJECT_LIBRARY_TARGET_NAME}-air_pressure
    ${PROJECT_LIBRARY_TARGET_NAME}-altimeter
    ${PROJECT_LIBRARY_TARGET_NAME}-logical_camera
    ${PROJECT_LIBRARY_TARGET_NAME}-magnetometer
    ${PROJECT_LIBRARY_TARGET_NAME}-imu
)

foreach(plugin_test ${dri_tests} ${tests})
  get_filename_component(BINARY_NAME ${plugin_test} NAME_WE)
  set(BINARY_NAME "${TEST_TYPE}_${BINARY_NAME}")
  if(TARGET ${BINARY_NAME})
    set(_env_vars)
    list(APPEND _env_vars "IGN_PLUGIN_PATH=$<TARGET_FILE_DIR:${PROJECT_LIBRARY_TARGET_NAME}>")
    list(APPEND _env_vars "DYLD_LIBRARY_PATH=${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

    set_tests_properties(${BINARY_NAME} PROPERTIES
      ENVIRONMENT "${_env_vars}")
  endif()
endforeach()

=== debian/changelog ===
ignition-sensors3 (3.4.0-1~focal) focal; urgency=medium

  * ignition-sensors3 3.4.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Tue, 16 Aug 2022 14:38:21 -0700

ignition-sensors3 (3.3.0-1~focal) focal; urgency=medium

  * ignition-sensors3 3.3.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Mon, 30 Aug 2021 14:40:34 -0700

ignition-sensors3 (3.2.0-1~focal) focal; urgency=medium

  * ignition-sensors3 3.2.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Mon, 08 Feb 2021 12:50:48 -0700

ignition-sensors3 (3.1.0-1~focal) focal; urgency=medium

  * ignition-sensors3 3.1.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Thu, 03 Sep 2020 12:01:04 -0700

ignition-sensors3 (3.0.0-1~focal) focal; urgency=medium

  * ignition-sensors3 3.0.0-1 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 10 Dec 2019 17:57:11 +0100

=== debian/control ===
Source: ignition-sensors3
Standards-Version: 3.9.8
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               doxygen,
               pkg-config,
               debhelper (>= 9),
               libignition-cmake2-dev (>= 2.13.0),
               libignition-common3-events-dev,
               libignition-common3-profiler-dev,
               libignition-math6-dev,
               libignition-msgs5-dev,
               libignition-plugin-dev,
               libignition-rendering3-ogre1-dev,
               libignition-rendering3-ogre2-dev,
               libignition-transport8-core-dev (>= 8.2.0),
               libignition-tools-dev,
               libsdformat9-dev
Vcs-Browser: https://github.com/gazebosim/gz-sensors
Vcs-Git: https://github.com/gazebosim/gz-sensors
Homepage: http://gazebosim.org/

Package: libignition-sensors3-core-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.13.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-plugin-dev,
         libignition-rendering3-ogre1-dev,
         libignition-rendering3-ogre2-dev,
         libignition-transport8-core-dev (>= 8.2.0),
         libignition-tools-dev,
         libsdformat9-dev,
         libignition-sensors3 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Development files
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.

Package: libignition-sensors3
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Shared library
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.

Package: libignition-sensors3-air-pressure-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.13.0),
         libignition-common3-events-dev,
         libignition-sensors3-core-dev (= ${binary:Version}),
         libsdformat9-dev,
         libignition-sensors3-air-pressure (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Dev files air-pressure
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for air-pressure sensor

Package: libignition-sensors3-air-pressure
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Lib air-pressure
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for air-pressure sensor

Package: libignition-sensors3-altimeter-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.13.0),
         libignition-common3-events-dev,
         libignition-sensors3-core-dev (= ${binary:Version}),
         libsdformat9-dev,
         libignition-sensors3-altimeter (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Dev files altimeter
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for altimeter sensor

Package: libignition-sensors3-altimeter
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Lib altimeter
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for altimeter sensor


Package: libignition-sensors3-camera-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.13.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-transport8-core-dev (>= 8.2.0),
         libignition-sensors3-core-dev (= ${binary:Version}),
         libsdformat9-dev,
         libignition-sensors3-camera (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Dev files Camera
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for Camera sensor

Package: libignition-sensors3-camera
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Lib Camera
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for Camera sensor

Package: libignition-sensors3-depth-camera-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.13.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-transport8-core-dev (>= 8.2.0),
         libignition-sensors3-core-dev (= ${binary:Version}),
         libignition-sensors3-camera-dev (= ${binary:Version}),
         libsdformat9-dev,
         libignition-sensors3-depth-camera (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Dev files depth-camera
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for depth-camera sensor

Package: libignition-sensors3-depth-camera
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Lib depth-camera
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  . Shared library for depth-camera sensor

Package: libignition-sensors3-imu-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.13.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-sensors3-core-dev (= ${binary:Version}),
         libsdformat9-dev,
         libignition-sensors3-imu (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Dev files imu
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for imu sensor

Package: libignition-sensors3-imu
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Lib imu
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for imu sensor


Package: libignition-sensors3-lidar-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.13.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-transport8-core-dev (>= 8.2.0),
         libignition-sensors3-core-dev (= ${binary:Version}),
         libsdformat9-dev,
         libignition-sensors3-lidar (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Dev files lidar
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for lidar sensor

Package: libignition-sensors3-lidar
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Lib lidar
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for lidar sensor

Package: libignition-sensors3-gpu-lidar-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.13.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-transport8-core-dev (>= 8.2.0),
         libignition-sensors3-core-dev (= ${binary:Version}),
         libignition-sensors3-lidar-dev (= ${binary:Version}),
         libsdformat9-dev,
         libignition-sensors3-gpu-lidar (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Dev files gpu-lidar
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for gpu-lidar sensor

Package: libignition-sensors3-gpu-lidar
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Lib gpu-lidar
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for gpu-lidar sensor

Package: libignition-sensors3-logical-camera-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.13.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-msgs5-dev,
         libignition-transport8-core-dev (>= 8.2.0),
         libignition-sensors3-core-dev (= ${binary:Version}),
         libsdformat9-dev,
         libignition-sensors3-logical-camera (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Dev files logical-camera
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for logical-camera sensor

Package: libignition-sensors3-logical-camera
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Lib logical-camera
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Shared library for logical-camera sensor

Package: libignition-sensors3-magnetometer-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.13.0),
         libignition-common3-events-dev,
         libignition-math6-dev,
         libignition-sensors3-core-dev (= ${binary:Version}),
         libsdformat9-dev,
         libignition-sensors3-magnetometer (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Dev files magnetometer
  Gazebo Sensors is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.
  .
  Development files for magnetometer sensor

Package: libignition-sensors3-magnetometer
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sensors classes and functions for robot apps - Lib magnetometer
